/* this is the cheklink addon for  SREhttp/2 installation program */ 

/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

crlf='0d0a'x
copyall=0

/*---   Load REXX libraries ----- */
/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
   say "Caution: could not find REXXLIB (is it in your LIBPATH?) "
   say "(hit ENTER to continue)"
   pull ff
end /* do */


ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  Install will look ugly ! "
  parse pull .
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

cls
say  " " ; say

call lineout, bold cy_ye
call lineout, "This is the CheckLink (ver 1.20a) installation program (December 2002)."
call lineout, "      (for the SREhttp/2 web server) "
call lineout, normal
call lineout,"      If you are installing CheckLink as a CGI-BIN script, or as a  "
call lineout,'      stand-alone program, please see the "by hand" installation'
call lineout,'      instructions in ChekLink.TXT.'
say "" 
say " This program will ask for the names of a few directories,"
say " and will copy a number of files to these directories."
say "  "

if yesno(" Are you ready to continue ")=1 then
 nop
else do
 say " See you later?.. "
 exit
end


nowdir=directory()

SRE2003_dir=sysini('USER','SRE2K','SRV_DIR')
filtername=sysini('USER','SRE2K','FILTER')
work_dir=sysini('USER','SRE2K','FILTER_DIR')
datadir=sysini('USER','SRE2K','DATADIR')

if SRE2003_dir='' | abbrev(SRE2003_dir,'ERROR:')=1 then do
  say "Before installing this addon, you must run SRE2003 (with SREhttp/2"
  say "as the filter) once -- this will initialize a few permanent variables"
  say "needed to guide addon installation. If you wish, you can run SRE2003, "
  say "immediately shut SRE2003 down, and then install this addon."
  exit
end

foo=work_dir||'\SREHTTP2.RXX'
if stream(foo,'c','query exists')=' ' then do
   say ' Could not find main SREhttp/2 program (SREHTTP2.RXX)'
   if yesno("  Are you sure you want to install this addon? ")=0 then exit
end  

chekhtm_dir=strip(datadir,,'\')||'\SRE2K\SREHTTP2\APPS\CHEKLINK'
web_dir=chekhtm_dir

addondir=work_dir||'\ADDON'
chekcmd_dir=addondir||'\CHEKLINK'
linkfile_dir=chekcmd_dir||'\LINKFILE'
chektemp_dir=chekcmd_dir||'\TEMP'

say "ChekLink components will be installed to: "
say 
say bold"       Program files: "normal||chekcmd_dir
say bold"        Demos & docs: "normal||chekhtm_dir
say bold" Linkage-files directory: "normal||linkfile_dir

if yesno(" Are you ready to copy the files ")=0 then do
   say " Okay, you can try again later "
   exit
end 

foo=is_dir(chekcmd_dir)
if foo=0 then do
    say "         Creating " chekcmd_dir
    wow=dosmkdir(chekcmd_dir)
    if wow=0 then do
      say "       Could not create " chekcmd_dir
      exit
    end
end

foo=is_dir(chekhtm_dir)
if foo=0 then do
    say "         Creating " chekhtm_dir
    wow=dosmkdir(chekhtm_dir)
    if wow=0 then do
      say "       Could not create " chekhtm_dir
      exit
    end
end

foo=is_dir(linkfile_dir)
if foo=0 then do
    say "         Creating " linkfile_dir
    wow=dosmkdir(linkfile_dir)
    if wow=0 then do
      say "       Could not create " linkfile_dir
      exit
    end
end
say " "


foo=is_dir(chektemp_dir)
if foo=0 then do
    say "         Creating " chektemp_dir
    wow=dosmkdir(chektemp_dir)
    if wow=0 then do
      say "       Could not create " chektemp_dir
      exit
    end
end
say " "
    

say "Copying program files"

foo=check_copy('CHEK_SRE.CMD',chekcmd_dir)
foo=check_copy('CHEKLINK.CMD',chekcmd_dir)
foo=check_copy('CHEKLNK2.CMD',chekcmd_dir)
foo=check_copy('CHEKRPT.CMD',chekcmd_dir)
foo=check_copy('CHEKFIX.CMD',chekcmd_dir)
foo=check_copy('CHEKINDX.CMD',chekcmd_dir)

foo=check_copy('CHECK1.SRF',chekcmd_dir)

say "Copying  HTML front-ends "
foo=check_copy('CHEK_SRE.HTM',web_dir)
foo=check_copy('CHEKLINK.TXT',web_dir)

say "Copying sample linkage and input files "
foo=check_copy('SAMPLE.STM',linkfile_dir)
foo=check_copy('CHEKLINK.SMP',chekcmd_dir)
foo=check_copy('CHEKRPT.SMP',chekcmd_dir)

adesc=' CheckLink is a multi-threaded, socket aware utility used to'
adesc=adesc||'create, verify, traverse, and index a web-tree; where '
adesc=adesc||'"web-tree" is defined as all URLs (in-line images, anchors, '
adesc=adesc||'etc.) that are referenced in a chosen HTML document, and in  '
adesc=adesc||'documents reachable from this document. CheckLink can be run as an'
adesc=adesc||'SREhttp/2 addon, or from an OS/2 command prompt.'

inifile=work_dir||'\ADDON\ADDONS.INI'
oo=sysini(inifile,'CheckLink','DESC',adesc)
oo=sysini(inifile,'CheckLink','URL','/sre2k/srehttp2/apps/cheklink/chek_sre.htm')
oo=sysini(inifile,'CheckLink','DOC','/sre2k/srehttp2/apps/cheklink/cheklink.txt')
oo=sysini(inifile,'CheckLink','TEMP',chektemp_dir' 'linkfile_dir)


say " "
say reverse " ------------------------------------------------- "normal
say bold " The CheckLink files and directories have been created. " normal
say " "
say " For some further hints, see the ChekLink.TXT file. "
say" "
if stream('CHEKLINK.TXT','c','query exists')<>'' then do
     ii=yesno(normal"      "bold"Would you like to view ChekLink.TXT ?"normal,,'N')
     if ii=1 then '@START  "The ChekLink Manual" /C /F /WIN E ChekLink.TXT'
end


exit

/* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1
 
   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd
 
   "@ANSI 2>NUL | rxqueue 2>NUL"
 
   thisRC = 0
 
   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */
 
 InitAnsiEnd:
 signal off error
 RETURN thisRC


/* -------------------- */
/* get a yes or no , return 1 if yes */
yesno:procedure expose normal reverse bold
parse arg fooa , allopt,altans
if altans<>" " & words(altans)>1 then do
   w1=strip(word(altans,1))
   w2=strip(word(altans,2))
   a1=left(w1,1) ; a2=left(w2,1)
   a1a=substr(w1,2) ; a2a=substr(w2,2)
end
else do
    a1='Y' ; a1a='es'
    a2='N' ; a2a='o'
end  /* Do */
ayn='  '||bold||a1||normal||a1a||'\'||bold||a2||normal||a2a
if allopt=1 then  ayn=ayn||'\'||bold||'A'||normal||'ll'

do forever
 foo1=normal||reverse||fooa||normal||ayn
 call charout,  foo1 normal ':'
 pull anans
 if abbrev(anans,a1)=1 then return 1
 if abbrev(anans,a2)=1 then return 0
 if allopt=1 & abbrev(anans,'A')=1 then return 2
end



/*******************************************/
/* check for existence of file, then ask user to copy or not */
/* note that for X.* type copies, it only checks once
   (not for each file, but just for any one of them */
/********************************************/
check_copy: procedure expose copyall reverse bold normal
parse arg file1, dest1 , asis
amess=''

if asis="" then do
  dest2=strip(dest1,'t','\')||'\'
  filename=dest2||file1
end
else do
  filename=dest1
end /* do */

if copyall=1 then signal doit3

aa=sysfiletree(filename,isit,'F')

ok=1
if aa<>0 then do
   say " Warning: error when looking for pre-existing copy of: " filename
   ok=yesno(" Do you want to copy this file (or files) anyways? ")
   if ok=1 & amess<>""  then
      ok=yesno(amess)
end

if isit.0>0 then do
  if pos('*',file1)=0 then do
      say " "
      say " A file exists with the name: " filename
      ok=yesno(" Do you want to overwrite this file? ",1)
       say ' '
      if ok=1 & amess<>""  then
           ok=yesno(amess)
  end
  else do
    say " "
      say " There is at least one file that matches: " filename
      say "  (this match may " bold " not " normal " be one of the files that will be copied!) "
      ok=yesno(" Do you want to copy these files? ",1)
      say ' '
      if ok=1 & amess<>""  then
           ok=yesno(amess)
  end  /* Do */

end

if ok=2 then do
  say " "
  say "A number of files will be overwritten (not just this one) "
  copyall=yesno(" Are you sure you want to do this?")
  if copyall=0 then
      ok=yesno(" Do you want to overwrite the current file (or files)? ")
      say ' '
end

if ok=0  then return 0

doit3:          /* jump here if copyall is on, or noask=1 */
'@COPY ' file1 dest1 ' > NUL '

return 1


/* return 1 if adir is an existing (possibly empty) directory , 0 if not */
is_dir:procedure 
parse arg adir

adir=strip(adir)
adir=strip(adir,'t','\')
nowdir=directory()
nowdrive=filespec('d',nowdir'\')
nowpath=filespec('p',nowdir'\')
adr=filespec('d',adir)
if adr='' then do
   if abbrev(adir,'\')=0 then 
       adir=nowdrive||nowpath||adir
   else
       adir=nowdrive||adir
end /* do */

foo=sysfiletree(adir,goo,'D')
if  goo.0>0  then return 1
return 0



